package de.thefeiter.liedgutverzeichnis.api

import android.content.Context
import com.android.volley.Response
import com.android.volley.VolleyError
import com.android.volley.toolbox.JsonObjectRequest
import de.thefeiter.liedgutverzeichnis.R
import de.thefeiter.liedgutverzeichnis.api.loader.LoaderObject
import de.thefeiter.liedgutverzeichnis.roomdb.AppDb

class SenderSongSuggestion(
    ctx: Context,
    db: AppDb?,
    completeCallback: () -> (Unit),
    songId: Int,
    followingSongId: Int
) : LoaderObject(
    ctx,
    db!!,
    completeCallback,
    ctx.getString(R.string.api_base_url) + ctx.getString(R.string.endpoint_song_suggestion)
        .format(songId, followingSongId)
) {
    override fun getRequest(url: String): JsonObjectRequest {
        return object : JsonObjectRequest(Method.POST,
            url,
            null,
            Response.Listener { completeCallback.invoke() },
            Response.ErrorListener { obj: VolleyError -> obj.printStackTrace() }) {
            /**
             * Passing some request headers
             */
            override fun getHeaders(): Map<String, String> {
                val headers = HashMap<String, String>()
                headers[ctx.getString(R.string.api_headers_token)] = user.apiToken
                return headers
            }
        }
    }

    fun send() {
        load()
    }
}