package de.thefeiter.liedgutverzeichnis.api.loader

import com.android.volley.NetworkResponse
import com.android.volley.Request
import com.android.volley.Response
import com.android.volley.toolbox.HttpHeaderParser
import java.util.*

open class InputStreamVolleyRequest(
    method: Int, mUrl: String?, private val listener: Response.Listener<ByteArray>,
    errorListener: Response.ErrorListener?, private val params: HashMap<String, String>?
) : Request<ByteArray>(method, mUrl, errorListener) {

    //create a static map for directly accessing headers
    var responseHeaders: Map<String, String>? = null


    override fun getParams(): Map<String, String>? {
        return params
    }

    override fun deliverResponse(response: ByteArray) {
        listener.onResponse(response)
    }

    override fun parseNetworkResponse(response: NetworkResponse): Response<ByteArray> {

        //Initialise local responseHeaders map with response headers received
        responseHeaders = response.headers

        //Pass the response data here
        return Response.success(response.data, HttpHeaderParser.parseCacheHeaders(response))
    }

    init {
        // this request would never use cache.
        setShouldCache(false)
    }
}