package de.thefeiter.liedgutverzeichnis.api.loader

import android.content.Context
import com.android.volley.Response
import com.android.volley.VolleyError
import de.thefeiter.liedgutverzeichnis.R
import de.thefeiter.liedgutverzeichnis.objects.User
import de.thefeiter.liedgutverzeichnis.roomdb.AppDb
import java.util.*

open class LoaderFile(
    @JvmField
    protected val context: Context,
    @JvmField
    protected val db: AppDb,
    protected val completeCallback: Runnable,
    @JvmField
    protected val url: String
) {

    protected val user = User()

    /**
     * Passing some request headers
     */
    open val request: InputStreamVolleyRequest?
        get() = object : InputStreamVolleyRequest(
            Method.GET,
            url,
            Response.Listener { response: ByteArray? -> onResponse(response) },
            Response.ErrorListener { error: VolleyError -> onError(error) },
            null
        ) {
            /**
             * Passing some request headers
             */
            /**
             * Passing some request headers
             */
            override fun getHeaders(): Map<String, String> {
                val headers = HashMap<String, String>()
                headers[context.getString(R.string.api_headers_token)] = user.apiToken
                return headers
            }
        }

    fun onError(error: VolleyError) {
        error.printStackTrace()
    }

    open fun onResponse(response: ByteArray?) {
        completeCallback.run()
    }

}