package de.thefeiter.liedgutverzeichnis.api.updater

import android.content.Context
import de.thefeiter.liedgutverzeichnis.R
import de.thefeiter.liedgutverzeichnis.api.loader.LoaderObject
import de.thefeiter.liedgutverzeichnis.exceptions.DatabaseUpdateException
import de.thefeiter.liedgutverzeichnis.objects.User
import de.thefeiter.liedgutverzeichnis.roomdb.AppDb
import org.json.JSONException
import org.json.JSONObject

class UpdaterUserPermissions(ctx: Context, db: AppDb, completeCallback: () -> Unit) :
    LoaderObject(
        ctx,
        db,
        completeCallback,
        ctx.getString(R.string.api_base_url) + ctx.getString(R.string.endpoint_whoami)
    ) {
    override suspend fun onResponse(response: JSONObject) {
        try {
            val user = User()
            user.superuser = response.getBoolean(ctx.getString(R.string.json_key_superuser))
            user.allowTopflop =
                response.getBoolean(ctx.getString(R.string.json_key_topflop_allowed))
        } catch (e: JSONException) {
            e.printStackTrace()
            DatabaseUpdateException(e.message).notifyUser(ctx)
        }
        completeCallback.invoke()
    }
}