package de.thefeiter.liedgutverzeichnis.api.uploader

import android.content.Context
import de.thefeiter.liedgutverzeichnis.api.ApiTest
import de.thefeiter.liedgutverzeichnis.api.SenderCategorySuggestion
import de.thefeiter.liedgutverzeichnis.api.SenderSongSuggestion
import de.thefeiter.liedgutverzeichnis.objects.SuggestionCache
import de.thefeiter.liedgutverzeichnis.roomdb.AppDb

class UploaderSuggestions(val ctx: Context, val db: AppDb, val completeCallback: () -> (Unit)) {

    fun testAndUpload() {
        ApiTest(
            ctx
        ).test(db) {
            sendRecursive(db.suggestionCacheDao().getFirst())
        }
    }

    fun upload() {
        sendRecursive(db.suggestionCacheDao().getFirst())
    }

    private fun sendRecursive(suggestion: SuggestionCache?) {

        suggestion?.let {
            db.suggestionCacheDao().delete(it.key)

            if (it.suggestedSongId != 0) {
                SenderSongSuggestion(
                    ctx,
                    db,
                    { sendRecursive(db.suggestionCacheDao().getFirst()) },
                    it.songId,
                    it.suggestedSongId
                ).send()
            } else if (it.categoryId != 0) {
                SenderCategorySuggestion(
                    ctx,
                    db,
                    { sendRecursive(db.suggestionCacheDao().getFirst()) },
                    it.songId,
                    it.categoryId
                ).send()
            }

        } ?: run {
            completeCallback.invoke()
        }
    }


}