package de.thefeiter.liedgutverzeichnis.helpers

import de.thefeiter.liedgutverzeichnis.objects.Song
import de.thefeiter.liedgutverzeichnis.roomdb.AppDb
import java.util.*

class ConfigFilterHelper {
    fun filterSongsByConfig(db: AppDb, songs: List<Song>): List<Song> {
        val songs = songs.toMutableList()
        val ids: IntArray = songs.stream().mapToInt { s: Song -> s.id }.toArray()

        val filteredSongs = db.songDao().loadByIdsFilteredByConfig(ids)

        val filteredIds: IntArray = filteredSongs.stream().mapToInt { s: Song -> s.id }.toArray()

        val toRemove: MutableList<Song> = ArrayList()

        for (song in songs) {
            if (!filteredIds.contains(song.id)) {
                toRemove.add(song)
            }
        }

        for (item in toRemove) {
            songs.remove(item)
        }

        return songs
    }
}