package de.thefeiter.liedgutverzeichnis.helpers

import android.content.Intent
import android.view.View
import com.google.android.material.snackbar.Snackbar
import de.thefeiter.liedgutverzeichnis.HelpActivity
import de.thefeiter.liedgutverzeichnis.R
import de.thefeiter.liedgutverzeichnis.ui.settings.SettingsActivity

class SnackbarHelper(val view: View) {

    fun makeNoBookSnackbar() {
        Snackbar.make(
            view,
            R.string.snackbar_no_book_notifivation,
            Snackbar.LENGTH_LONG
        ).setAction(R.string.activity_settings_title) {
            val intent = Intent(view.context, SettingsActivity::class.java)
            view.context.startActivity(intent)
        }.show()
    }

    fun makeHelpSnackbar() {
        Snackbar.make(
            view,
            R.string.snackbar_open_help,
            10000
        ).setAction(R.string.open_help) {
            val intent = Intent(view.context, HelpActivity::class.java)
            view.context.startActivity(intent)
        }.show()
    }

    fun makeSnackbar(message: String) {
        Snackbar.make(
            view,
            message,
            Snackbar.LENGTH_LONG
        ).show()
    }

    fun makeSnackbar(message: String, anchor: View) {
        val snackbar = Snackbar.make(
            view,
            message,
            Snackbar.LENGTH_LONG
        )

        snackbar.anchorView = anchor
        snackbar.show()
    }
}