package de.thefeiter.liedgutverzeichnis.objects;

import androidx.annotation.NonNull;
import androidx.room.ColumnInfo;
import androidx.room.Entity;
import androidx.room.PrimaryKey;

import java.io.Serializable;

@Entity(tableName = "songs")
public class Song implements Serializable {
    @PrimaryKey
    @NonNull
    @ColumnInfo(name = "songId")
    public int id;

    public String title;

    public String beginning;

    public String keywords;

    public String text;

    public int calls;

    public int pdfId;

    public int bookId;

    public String page;

    public int score = 0;

    public boolean favorite;

    @ColumnInfo(defaultValue = "0.0")
    public double favoriteUpdateTimestamp;

    @ColumnInfo(defaultValue = "0")
    public boolean bookmark;

    @ColumnInfo(defaultValue = "0.0")
    public double bookmarkUpdateTimestamp;


}
