package de.thefeiter.liedgutverzeichnis.objects

import android.content.SharedPreferences
import androidx.appcompat.app.AppCompatActivity
import de.thefeiter.Liedgutverzeichnis
import de.thefeiter.liedgutverzeichnis.ui.settings.*

const val DEFAULT_TOKEN_VALUE = ""
class User {
    private val sharedPreferences: SharedPreferences =
        Liedgutverzeichnis.getAppContext()
            .getSharedPreferences(PREFERENCE_NAME, AppCompatActivity.MODE_PRIVATE)

    var apiToken: String
        get() {
            return sharedPreferences.getString(SHARED_PREFS_USER_API_TOKEN, DEFAULT_TOKEN_VALUE)
                .toString()
        }
        set(value) {
            sharedPreferences.edit().putString(SHARED_PREFS_USER_API_TOKEN, value).apply()
        }

    var superuser: Boolean
        get() {
            return sharedPreferences.getBoolean(SHARED_PREFS_USER_SUPERUSER, false)
        }
        set(value) {
            sharedPreferences.edit().putBoolean(SHARED_PREFS_USER_SUPERUSER, value).apply()
        }

    var allowTopflop: Boolean
        get() {
            return sharedPreferences.getBoolean(SHARED_PREFS_USER_TOPFLOP_ALLOWED, false)
        }
        set(value) {
            sharedPreferences.edit().putBoolean(SHARED_PREFS_USER_TOPFLOP_ALLOWED, value).apply()
        }

    var lastTokenCheck: Long
        get() {
            return sharedPreferences.getLong(SHARED_PREFS_USER_LAST_AUTH_CHECK, 0L)
        }
        set(value) {
            sharedPreferences.edit().putLong(SHARED_PREFS_USER_LAST_AUTH_CHECK, value).apply()
        }

}