package de.thefeiter.liedgutverzeichnis.roomdb

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.Query
import de.thefeiter.liedgutverzeichnis.objects.Book

@Dao
interface DAOBook {
    @Query("SELECT * FROM books")
    fun getAll(): List<Book>

    @Insert
    fun insert(book: Book?)

    @Query("DELETE FROM books")
    fun deleteAll()

    @Query("SELECT books.* FROM books INNER JOIN bookSettings ON bookSettings.bookId = books.bookId WHERE bookSettings.active")
    fun loadAllByUser(): List<Book>

    @Query("SELECT * FROM books WHERE bookId = :bookId LIMIT 1")
    fun findById(bookId: Int): Book
}