package de.thefeiter.liedgutverzeichnis.roomdb

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.Query
import de.thefeiter.liedgutverzeichnis.objects.BookSetting

@Dao
interface DAOBookSetting {
    @Insert
    fun insert(bookSetting: BookSetting?)

    @Query("DELETE FROM bookSettings")
    fun deleteAll()

    @Query("SELECT bookSettings.* FROM bookSettings")
    fun getAll(): List<BookSetting>

    @Query("SELECT COUNT(*) FROM bookSettings WHERE bookSettings.active")
    fun getActiveCount(): Int

    @Query("SELECT EXISTS(SELECT 1 FROM bookSettings WHERE bookId = :bookId LIMIT 1)")
    fun exists(bookId: Int): Boolean

    @Query("UPDATE bookSettings SET active = :active, updated = :timestamp WHERE bookId = :bookId")
    fun update(active: Boolean, timestamp: Double, bookId: Int)

    @Query("UPDATE bookSettings SET active = NOT active, updated = :timestamp")
    fun invertAll(timestamp: Double)
}