package de.thefeiter.liedgutverzeichnis.roomdb

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.Query
import de.thefeiter.liedgutverzeichnis.objects.Category

@Dao
interface DAOCategory {
    @Query("SELECT categories.* FROM categories WHERE categoryId > 0")
    fun getAll(): List<Category>

    @Query("SELECT categories.* FROM categories WHERE categoryId == :categoryId LIMIT 1")
    fun findById(categoryId: Int): Category

    @Query("SELECT categories.* FROM categories INNER JOIN categoryRelations ON categoryRelations.categoryId = categories.categoryId WHERE categoryRelations.songId = :songId")
    fun findBySongId(songId: Int): List<Category>

    @Insert
    fun insert(category: Category?)

    @Query("DELETE FROM categories")
    fun deleteAll()
}