package de.thefeiter.liedgutverzeichnis.roomdb;

import androidx.room.Dao;
import androidx.room.Insert;
import androidx.room.Query;

import java.util.List;

import de.thefeiter.liedgutverzeichnis.objects.HistoryElement;
import de.thefeiter.liedgutverzeichnis.objects.HistorySong;
import de.thefeiter.liedgutverzeichnis.objects.Song;

@Dao
public interface DAOSongHistory {

    @Insert
    void insert(HistoryElement historyElement);

    @Query("DELETE FROM history")
    void deleteAll();

    @Query("INSERT INTO history (songId, timestamp)" +
            "SELECT :songId as song_id, :timestamp as timestamp " +
            "WHERE :songId != IFNULL((SELECT songId FROM history ORDER BY history.timestamp DESC LIMIT 1),0) " +
            "LIMIT 1")
    void addSong(int songId, double timestamp);

    @Query("SELECT * FROM history")
    List<HistoryElement> getAll();

    @Query("SELECT songs.*, timestamp FROM history INNER JOIN songs on songs.songId=history.songId ORDER BY history.timestamp DESC")
    List<HistorySong> getAllAsHistorySong();

    @Query("SELECT songs.* FROM history INNER JOIN songs on songs.songId=history.songId ORDER BY history.timestamp DESC LIMIT 1")
    Song getLastAsSong();


}
