package de.thefeiter.liedgutverzeichnis.roomdb

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.Query
import de.thefeiter.liedgutverzeichnis.objects.Song
import de.thefeiter.liedgutverzeichnis.objects.SongPathSong

@Dao
interface DAOSongPath {
    @Insert
    fun insert(songPathSong: SongPathSong?)

    @Query("DELETE FROM songPath")
    fun deleteAll()

    @get:Query("SELECT songs.* FROM songPath INNER JOIN songs on songs.songId=songPath.songId ORDER BY songPath.`index` ASC LIMIT 1")
    val nextAsSong: Song?

    @Query("DELETE FROM songPath WHERE songPath.`key` in (SELECT `key` FROM songPath ORDER BY songPath.`index` ASC LIMIT 1)")
    fun deleteCurrent()
}