package de.thefeiter.liedgutverzeichnis.roomdb

import androidx.room.Dao
import androidx.room.Insert
import androidx.room.Query
import de.thefeiter.liedgutverzeichnis.objects.Song
import de.thefeiter.liedgutverzeichnis.objects.SongSuggestion

@Dao
interface DAOSongSuggestion {
    @Insert
    fun insert(songSuggestion: SongSuggestion?)

    @Query("DELETE FROM songSuggestions")
    fun deleteAll()

    @Query("SELECT DISTINCT songs.* FROM songs INNER JOIN songSuggestions ON songs.songId = songSuggestions.suggestedSongId WHERE songSuggestions.songId=:songId")
    fun findAsSongBySongId(songId: Int): List<Song>

    @Query("SELECT DISTINCT songs.* FROM songs INNER JOIN songSuggestions ON songs.songId = songSuggestions.songId WHERE songSuggestions.suggestedSongId=:songId")
    fun findAsSongBySongIdReversed(songId: Int): List<Song>

    fun findAsSongBySongIdBidirectional(songId: Int): List<Song> {
        val suggestions = findAsSongBySongId(songId).toMutableList()
        val reverseSuggestions = findAsSongBySongIdReversed(songId)

        reverseSuggestions.forEach { reverseSuggestion ->
            if (!suggestions.any { it.id == reverseSuggestion.id }) {
                suggestions.add(reverseSuggestion)
            }
        }
        return suggestions
    }
}