package de.thefeiter.liedgutverzeichnis.ui.main;

import static de.thefeiter.liedgutverzeichnis.SongChooserKt.BOOK_ID;

import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.recyclerview.widget.RecyclerView;

import org.jetbrains.annotations.NotNull;

import java.util.List;

import de.thefeiter.liedgutverzeichnis.R;
import de.thefeiter.liedgutverzeichnis.SongChooser;
import de.thefeiter.liedgutverzeichnis.objects.Book;


public class AdapterBookList extends RecyclerView.Adapter<AdapterBookList.View_Holder> {

    private final List<de.thefeiter.liedgutverzeichnis.objects.Book> books;

    public AdapterBookList(List<de.thefeiter.liedgutverzeichnis.objects.Book> books) {
        this.books = books;
    }


    @NotNull
    @Override
    public View_Holder onCreateViewHolder(ViewGroup parent, int viewType) {
        LayoutInflater layoutInflater = LayoutInflater.from(parent.getContext());
        View listItem = layoutInflater.inflate(R.layout.item_booklist, parent, false);
        return new View_Holder(listItem);
    }

    @Override
    public void onBindViewHolder(View_Holder holder, int position) {
        final Book book = books.get(position);
        holder.bookName.setText(book.name);
        //bei click on category
        holder.relativeLayout.setOnClickListener(view -> {
            Context context = view.getContext();


            //start new activity with song object by intent
            Intent intent = new Intent(context, SongChooser.class);
            intent.putExtra(BOOK_ID, book.id);
            context.startActivity(intent);


        });

    }

    @Override
    public int getItemCount() {
        return books.size();
    }

    public static class View_Holder extends RecyclerView.ViewHolder {
        public final TextView bookName;
        public final RelativeLayout relativeLayout;

        public View_Holder(View itemView) {
            super(itemView);
            //load ui elements
            this.bookName = itemView.findViewById(R.id.bookName);
            relativeLayout = itemView.findViewById(R.id.bookItemRelativeLayout);
        }
    }

}
