package de.thefeiter.liedgutverzeichnis.ui.main;

import static de.thefeiter.liedgutverzeichnis.SongChooserKt.CATEGORY_ID;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.TextView;

import androidx.recyclerview.widget.RecyclerView;

import org.jetbrains.annotations.NotNull;

import java.util.List;

import de.thefeiter.liedgutverzeichnis.R;
import de.thefeiter.liedgutverzeichnis.SongChooser;
import de.thefeiter.liedgutverzeichnis.objects.Category;


public class AdapterCatList extends RecyclerView.Adapter<AdapterCatList.View_Holder> {

    private final List<de.thefeiter.liedgutverzeichnis.objects.Category> categories;

    public AdapterCatList(List<de.thefeiter.liedgutverzeichnis.objects.Category> categories) {
        this.categories = categories;
    }

    @NotNull
    @Override
    public View_Holder onCreateViewHolder(ViewGroup parent, int viewType) {
        LayoutInflater layoutInflater = LayoutInflater.from(parent.getContext());
        View listItem = layoutInflater.inflate(R.layout.item_catlist, parent, false);
        return new View_Holder(listItem);
    }

    @Override
    public void onBindViewHolder(View_Holder holder, int position) {
        final Category category = categories.get(position);
        holder.catName.setText(category.name);
        //bei click on category
        holder.relativeLayout.setOnClickListener(view -> {
            Context context = view.getContext();

            //start new activity with song object by intent
            Intent intent = new Intent(context, SongChooser.class);
            intent.putExtra(CATEGORY_ID, category.id);
            context.startActivity(intent);

        });

        holder.catLabel.setColorFilter(Color.parseColor(category.color));
    }


    @Override
    public int getItemCount() {
        return categories.size();
    }

    public static class View_Holder extends RecyclerView.ViewHolder {
        public final TextView catName;
        public final ImageView catLabel;
        public final RelativeLayout relativeLayout;

        public View_Holder(View itemView) {
            super(itemView);
            this.catName = itemView.findViewById(R.id.catName);
            this.catLabel = itemView.findViewById(R.id.catIcon);
            relativeLayout = itemView.findViewById(R.id.catItemRelativeLayout);
        }
    }
}