package de.thefeiter.liedgutverzeichnis.ui.main;

import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import java.util.List;

import de.thefeiter.liedgutverzeichnis.MainActivity;
import de.thefeiter.liedgutverzeichnis.R;
import de.thefeiter.liedgutverzeichnis.objects.Category;
import de.thefeiter.liedgutverzeichnis.roomdb.AppDb;

/**
 * A simple {@link Fragment} subclass.
 * Use the {@link FragmentCategories#newInstance} factory method to
 * create an instance of this fragment.
 */
public class FragmentCategories extends Fragment {


    //private PageViewModel pageViewModel;
    //!!private FragmentMainBinding binding;
    private Context mContext;



    public Fragment newInstance(Context context) {
        mContext = context;
        return this;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_cats, container, false);

        AppDb db = MainActivity.getAppDb();
        List<Category> categories = db.categoryDao().getAll();

        Category uncategorized = new Category();

        uncategorized.id = Category.UNCATEGORIZED;
        uncategorized.name = getString(R.string.category_uncategorized);
        uncategorized.color = "#" + Integer.toHexString(ContextCompat.getColor(mContext, R.color.grey));

        categories.add(uncategorized);

        RecyclerView recyclerView = view.findViewById(R.id.catList);

        AdapterCatList adapter = new AdapterCatList(categories);
        recyclerView.setHasFixedSize(true);
        recyclerView.setLayoutManager(new LinearLayoutManager(mContext));
        recyclerView.setAdapter(adapter);


        return view;
    }
}