package de.thefeiter.liedgutverzeichnis.ui.main

import android.content.Context
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.fragment.app.Fragment
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import de.thefeiter.liedgutverzeichnis.MainActivity.Companion.getAppDb
import de.thefeiter.liedgutverzeichnis.R
import de.thefeiter.liedgutverzeichnis.objects.HistorySong

class FragmentHistory(private val mContext: Context) : Fragment() {
    private val db = getAppDb()
    private lateinit var recyclerView: RecyclerView

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {
        // Inflate the layout for this fragment
        val fragmentView = inflater.inflate(R.layout.fragment_history, container, false)
        recyclerView = fragmentView.findViewById(R.id.historyRecyclerView)


        //load existing books
        val historySongs = ArrayList<HistorySong>() //init in onresume


        //initialize book list adapter
        val adapter = AdapterHistoryList(historySongs)
        recyclerView.setHasFixedSize(true)
        recyclerView.layoutManager = LinearLayoutManager(mContext)
        recyclerView.adapter = adapter
        return fragmentView
    }

    override fun onResume() {
        super.onResume()
        // Inflate the layout for this fragment
        val adapter = recyclerView.adapter as AdapterHistoryList

        adapter.updateData(db.historyDao().allAsHistorySong)

        adapter.notifyDataSetChanged()
    }
}