package de.thefeiter.liedgutverzeichnis.ui.main;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import java.util.ArrayList;

import de.thefeiter.liedgutverzeichnis.MainActivity;
import de.thefeiter.liedgutverzeichnis.R;
import de.thefeiter.liedgutverzeichnis.helpers.SearchHelper;

/**
 * A placeholder fragment containing a simple view.
 */
public class FragmentSearch extends Fragment {


    public Fragment newInstance() {
        return this;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

    }

    @SuppressLint("NotifyDataSetChanged")
    @Override
    public View onCreateView(
            @NonNull LayoutInflater inflater, ViewGroup container,
            Bundle savedInstanceState) {
        Context context = this.getContext();

        //!!binding = FragmentMainBinding.inflate(inflater, container, false);
        View view = inflater.inflate(R.layout.fragment_search, container, false);


        EditText queryBox = view.findViewById(R.id.searchQuery);

        Button searchButton = view.findViewById(R.id.querySubmit);

        // show search results in recycler view
        RecyclerView resultRecyclerView = view.findViewById(R.id.searchRecyclerView);
        resultRecyclerView.setLayoutManager(new LinearLayoutManager(context));
        AdapterSongList adapter = new AdapterSongList(new ArrayList<>());
        resultRecyclerView.setAdapter(adapter);

        // if search button clicked, start search
        searchButton.setOnClickListener(v -> {

            SearchHelper sp = new SearchHelper(MainActivity.getAppDb(), context);

            adapter.songs = sp.search(String.valueOf(queryBox.getText()), view);
            adapter.notifyDataSetChanged();


            //hide keyboard
            if (context != null) {
                InputMethodManager manager = (InputMethodManager) context.getSystemService(Context.INPUT_METHOD_SERVICE);
                manager.hideSoftInputFromWindow(view.getWindowToken(), 0);
            }

        });

        //If submit via keyboard, click search button
        queryBox.setOnEditorActionListener((v, actionId, event) -> {
            if (actionId == EditorInfo.IME_ACTION_NEXT || actionId == EditorInfo.IME_ACTION_DONE) {
                searchButton.performClick();
                return true;
            }
            return false;
        });


        return view;
    }
}