package de.thefeiter.liedgutverzeichnis.ui.main;

import android.content.Context;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.lifecycle.Lifecycle;
import androidx.viewpager2.adapter.FragmentStateAdapter;

import org.jetbrains.annotations.NotNull;

import de.thefeiter.liedgutverzeichnis.R;

/**
 * A [FragmentPagerAdapter] that returns a fragment corresponding to
 * one of the sections/tabs/pages.
 */
public class SectionsPagerAdapter extends FragmentStateAdapter {


    private static final int[] TAB_TITLES = new int[]{
            R.string.tab_text_1,
            R.string.tab_text_2,
            R.string.tab_text_4,
            R.string.tab_text_6,
            R.string.tab_text_3,
            R.string.tab_text_5};
    private static final int[] TAB_ICONS = new int[]{
            R.drawable.ic_baseline_search_black_24dp,
            R.drawable.ic_round_category_black_24dp,
            R.drawable.ic_baseline_star_border_black_24dp,
            R.drawable.ic_round_menu_book_red_50_48dp,
            R.drawable.ic_baseline_bookmarks_black_24dp,
            R.drawable.ic_round_history_black_24dp};
    private final Context mContext;

    public SectionsPagerAdapter(Context context, FragmentManager fragmentManager, Lifecycle lifecycle) {
        super(fragmentManager, lifecycle);
        mContext = context;
    }

    @NotNull
    @Override
    public Fragment createFragment(int position) {
        // getItem is called to instantiate the fragment for the given page.
        // Return a PlaceholderFragment (defined as a static inner class below).

        Fragment frag;

        if (position == 0) {
            frag = new FragmentSearch().newInstance();
        }else if(position == 1){
            frag = new FragmentCategories().newInstance(this.mContext);
        }else if(position == 2){
            frag = new FragmentFavorites(this.mContext);
        }else if (position == 3) {
            frag = new FragmentBooks(this.mContext);
        } else if (position == 4) {
            frag = new FragmentBookmarks(this.mContext);
        } else if (position == 5) {
            frag = new FragmentHistory(this.mContext);
        } else {
            frag = new FragmentBooks(this.mContext);
        }
        return frag;
    }

    @Override
    public int getItemCount() {
        return TAB_TITLES.length;
    }

    public int[] getTitles() {
        return TAB_TITLES;
    }

    public int[] getIcons() {
        return TAB_ICONS;
    }
}