package de.thefeiter.liedgutverzeichnis.ui.songdetails

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import de.thefeiter.liedgutverzeichnis.R

class PagesAdapter(private val pages: List<BookPage>) :
    RecyclerView.Adapter<PagesAdapter.ViewHolder>() {

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): PagesAdapter.ViewHolder {
        val layoutInflater = LayoutInflater.from(parent.context)
        val listItem: View = layoutInflater.inflate(R.layout.item_pages, parent, false)
        return ViewHolder(listItem)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val page = pages[position]

        holder.bookName.text = page.bookName
        holder.page.text = page.page
    }


    override fun getItemCount(): Int {
        return pages.size
    }

    inner class ViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {
        val bookName: TextView = itemView.findViewById(R.id.pageItemBookName)
        val page: TextView = itemView.findViewById(R.id.pageItemPage)
    }
}