package de.thefeiter.liedgutverzeichnis.ui.songdetails

import android.content.Context
import android.content.Intent
import android.view.View
import androidx.fragment.app.FragmentManager
import de.thefeiter.liedgutverzeichnis.MainActivity
import de.thefeiter.liedgutverzeichnis.R
import de.thefeiter.liedgutverzeichnis.objects.Song
import de.thefeiter.liedgutverzeichnis.roomdb.AppDb
import de.thefeiter.liedgutverzeichnis.ui.dialogs.SongSuggestionDialog
import de.thefeiter.liedgutverzeichnis.ui.views.SongPill

class SuggestionPillMaker(
    private val context: Context,
    private val db: AppDb
) {

    val normalPillOnClick = { song: Song ->
        //start new activity with song object by intent
        val intent = Intent(context, SongDetails::class.java)
        intent.putExtra(MainActivity.SONG_DETAILS, song.id)
        context.startActivity(intent)
    }

    fun normalPill(song: Song): View {
        return normalPill(song, normalPillOnClick)
    }

    fun normalPill(song: Song, onClick: (Song) -> Unit): View {
        val suggestionPill = SongPill(context, null)

        suggestionPill.label.text = song.title

        suggestionPill.setOnClickListener {
            onClick(song)
        }
        return suggestionPill
    }


    fun newPill(song: Song, fragmentManager: FragmentManager): View {
        val suggestionPill = SongPill(context, null)

        suggestionPill.setNew()

        suggestionPill.label.setText(R.string.pill_new)

        suggestionPill.setOnClickListener {
            try {
                // try to reshow setup dialog
                val songSuggestionDialog = SongSuggestionDialog(db, song, context)
                songSuggestionDialog.show(fragmentManager, null)
            } catch (e: ClassCastException) {
                e.printStackTrace()
            }

        }
        return suggestionPill
    }


}